﻿$("a#tabsSelector").click(function() {
  // Hide TOC when tabSelect is clicked
  if ($("iframe#toc").css("display") != "none")
    hideTOCbyZeroHeight($("a#topicSelector"));
  // Do the job
  $("#tabs").slideToggle("fast");
  if ($(this).hasClass("bgarrow_down_white"))
    $(this).addClass("bgarrow_up_white").removeClass("bgarrow_down_white");
  else 
    $(this).addClass("bgarrow_down_white").removeClass("bgarrow_up_white"); 
});

var firstLoad = true;
var tocFrameHeight = 0; 
var tocHidden = true;
function hideTOCbyZeroHeight(elem) {
  if (!tocHidden) {
    tocFrameHeight = $("iframe#toc").height();
    $("iframe#toc").animate({ height: 0 }, 500);
	tocHidden = true;
  }
  elem.addClass("bgarrow_down_white").removeClass("bgarrow_up_white");
}
function showTOCbyDefaultHeight() {
  $("iframe#toc").show("fast");
  $("iframe#toc").animate({ height: tocFrameHeight }, 500);
  tocHidden = false;
}
$("a#topicSelector").click(function() { 
  // Hide tabs when topicSelect is clicked
  $("#tabs").hide("fast");
  $("a#tabsSelector").addClass("bgarrow_down_white").removeClass("bgarrow_up_white");
  // Do the job
  if ($(this).hasClass("bgarrow_down_white")) {
    if (firstLoad) {
      if (window.chrome)
        $("iframe#toc").css("display", "inline");
      $("iframe#toc").on("load", function(){
        $('iframe#toc').resize();
      });
      $("iframe#toc").show("fast", function() {
        $(this).attr( 'src', function ( i, val ) { return val; });
      });
      tocHidden = false;
    } else
      showTOCbyDefaultHeight();
    firstLoad = false;
    $(this).addClass("bgarrow_up_white").removeClass("bgarrow_down_white");
  } else
    hideTOCbyZeroHeight($(this));
});

$("a#desktopSelector").click(function(e) { 
  var mvp = document.getElementById('myViewport');
  mvp.setAttribute('content','width=67em, initial-scale=1.0');
  mvp = document.getElementById('mobCSS');
  mvp.setAttribute('href','about:blank');
  mvp = document.getElementById('mobrtlCSS');
  if (mvp) mvp.setAttribute('href','about:blank');
  mvp = document.getElementsByTagName('body')[0].style = "width: 67em;";
  $("#tabs a").css("background-color", "transparent");
  $(this).css("display", "none");
  showTOCbyDefaultHeight();
  $(window).scrollTop(0); 
  e.preventDefault();
});

// Expanders in content
//  a.dropdown-toggle
$("#content").on("click", "a.dropdown-toggle", function(e) {
  var state = $( this ).attr("data-state");
  if (state == "0") state = "1"; else state = "0";
  $( this ).attr("data-state", state);
  var element = $( this ).attr("id").replace("_LINK", "");
  var elementIcon = $( this ).attr("id").replace("_LINK", "_ICON");
  $( "#" + element ).slideToggle("fast");
  $( "#" + elementIcon ).attr("src", $( this ).attr("data-src" + state));
  $( "#" + elementIcon ).attr("alt", "state" + state);
  adjustFooterPosition();
});
//  img.dropdown-toggle-icon
$("#content").on("click", "img.dropdown-toggle-icon", function(e) {
  var imgSrc = "";
  var state = 0;
  var element = $( this ).attr("id").replace("_ICON", "");
  var elementLink = $( this ).attr("id").replace("_ICON", "_LINK");
  var currentState = $( "#" + elementLink ).attr("data-state");
  if (currentState == 0) {
    imgSrc = $( "#" + elementLink ).attr("data-src1");
    state = 1;
  } else {
    imgSrc = $( "#" + elementLink ).attr("data-src0");
    state = 0;
  }
  $( this ).attr("alt", "state" + state);
  $( this ).attr("src", imgSrc);
  $( "#" + element ).slideToggle("fast");
  $( "#" + elementLink ).attr("data-state", state);
  adjustFooterPosition();
});

// Footer links target=_blank
$("#footer a").attr("target", "_blank");
$("#manage-cookies").removeAttr("target");

$(document).on('keyup',function(event) {
  if (event.keyCode == 27) { // ESC handler
    $("#languagemenu").hide("fast");
    $("#versionSelector").hide("fast");
    if ($("#lightbox")) hideLightBox();
  }
});

// If clicked on lightbox, delete it
function hideLightBox() {
  if ($("#lightbox"))
    $("#lightbox").animate({opacity: 0}, 200, function() {$(this).remove();});
  $("#offlineSearch").css("height", "6ex");
}
$("body").on("click", "#lightbox", function(e) { hideLightBox(); });

// Close lngselectbox and verselectbox if clicked with mouse outside
var mouse_is_inside_top = false;
var mouse_is_inside_header = false;
$('#top').hover(function(){ 
  mouse_is_inside_top=true; 
}, function(){ 
  mouse_is_inside_top=false; 
});
$('#header').hover(function(){ 
  mouse_is_inside_header=true; 
}, function(){ 
  mouse_is_inside_header=false; 
});
$("body").mouseup(function(){ 
  if(!mouse_is_inside_top)    $("#languagemenu").hide("fast");
  if(!mouse_is_inside_header) $("#versionSelector").hide("fast");
});

// Resize TOC and content  
var arrowDefaultPos = 8; // default position of the slide arrow from top
function createVSplitter(menu, content) {
  if (!menu || !menu.width()) return;
  var menuOrigWidthPercent = 25;
  var contentOrigWidthPrecent = 72;
  var splitterWidthPercent = 1;
  var ao = { duration: 800, queue: false }; // Animation object
  var hmsplitter = $('<div/>')
    .attr("id", "hmsplitter")
    .addClass("bgarrow_left_FullBlack")
    .css("width", splitterWidthPercent + "%");
  hmsplitter.insertBefore(content);
  resizeVSplitter();
  content.width((contentOrigWidthPrecent - splitterWidthPercent) + "%");
  var defaultOpacity = hmsplitter.css("opacity");
  $('#hmsplitter').click(function() {
    if (menu.width() > 5) { // in some cases IE may throw 0.40 or larger, that is why offset is 5px
      // Slide away
      menu.animate({width: "0%"}, ao);
      content.animate({width: (menuOrigWidthPercent + contentOrigWidthPrecent - splitterWidthPercent) + "%"}, ao);
      $(this).removeClass("bgarrow_left_FullBlack").addClass("bgarrow_right_FullBlack");
      $(this).css("opacity", "1");
      $(this).css("background-position", "left "+arrowDefaultPos+"px");
    } else {
      // Slide in
      content.animate({width: (contentOrigWidthPrecent - splitterWidthPercent) + "%"}, ao);
      menu.animate({width: (menuOrigWidthPercent) + "%"}, ao);
      $(this).removeClass("bgarrow_right_FullBlack").addClass("bgarrow_left_FullBlack");
      $(this).css("opacity", defaultOpacity);
      $(this).css("background-position", "right "+arrowDefaultPos+"px");
    }
    moveScrollVSplitter();
  });
}
if ($("html").attr("dir") == "rtl");
else
  createVSplitter($("iframe#toc"), $("#content"));
function resizeVSplitter() {
  var hmsplitter = $("#hmsplitter");
  if (!hmsplitter) return;
  hmsplitter.css("height", $("#content").height() + "px");
}
function moveScrollVSplitter() {
  var hmsplitter = $("#hmsplitter");
  if (document.getElementById("hmsplitter") === null) return;
  var posFinal = arrowDefaultPos;
  var arrowPos = $(window).scrollTop() - hmsplitter.position().top - arrowDefaultPos;
  if (arrowPos > arrowDefaultPos)
    posFinal = arrowPos;
  var orientation = "right"; 
  if (!hmsplitter.css("background-position")) return;
  if (hmsplitter.css("background-position").indexOf("left") > -1 || hmsplitter.css("background-position").indexOf("0%") == 0)
    orientation = "left";
  hmsplitter.css("background-position", orientation+" "+posFinal+"px");
}

// DivScroll for tables
function adjustTablesForMobile() {  
  if ($("#topicText table.Table_big")) $("#topicText table.Table_big").wrap( "<div class='mobileTableBig'></div>" ); 
  if ($("#topicText table.Table_code")) $("#topicText table.Table_code").wrap( "<div class='mobileTableBig'></div>" );
}
adjustTablesForMobile();

// In case of large resolutions and full-height browsers
function adjustFooterPosition() {
  var headerHeight = $("#top").height() + $("#header").height();
  var contentHeight = $("#content").height();
  var contentHeightInitial = contentHeight;
  var footerHeight = $("#footerContainer").height();
  var tocHeight = 0;
  if ($("#toc").height()) tocHeight = $("#toc").height();
  if (tocHeight > contentHeight)
    contentHeight = tocHeight;
  if ($("#alerts").height() && $("#alerts").css("display") != "none")
    contentHeight = contentHeight + $("#alerts").height();  
  if ($("#faq").height() && $("#faq").css("display") != "none")
    contentHeight = contentHeight + $("#faq").height(); 
  if ($("#tabs").height())
    contentHeight = contentHeight + $("#tabs").height();
  if ($("#breadcrumbs").height() && $("#breadcrumbs").css("display") != "none")
    contentHeight = contentHeight + $("#breadcrumbs").height();  
  //alert("Window height: " + $(window).height() + " and header: " + headerHeight + " and content initial / now: " + contentHeightInitial + "/" + contentHeight + " and TOC: " + tocHeight + " and Footer: " + footerHeight);
  if ($(window).height() - footerHeight - headerHeight - 90 > contentHeight) {
    $("#footerContainer")
      .css("position", "fixed")
      .css("bottom", "0px");
  } else {
    $("#footerContainer")
      .css("position", "static")
      .css("bottom", "auto")
      .css("bottom", "initial");
  }
}
var ableToChange = true; var ableToChangeTimeout = 150;
function adjustRevisionPosition() {
  if (ableToChange == false) return;
  if ($("#revision") && !$("#revision").hasClass("nomanipulate")) {
    revisionHeight = $("#revision").height();
    var footerPosition = $("#footer").position().top;
    var scrollTopPosition = $(window).scrollTop();
    var footerIsVisible = windowHeight + scrollTopPosition - footerPosition > 0;
    //alert("Window height: " + $(window).height() + " and footerPos: " + footerPosition + " and scrollTopPosition: " + scrollTopPosition + "footerIsVisible: " + footerIsVisible);
    if (footerIsVisible || windowHeight < 700) {
      if (!$("#revision").hasClass("positionStatic")) {
        $("#revision").removeClass().addClass("positionStatic");
        ableToChange = false;
        setTimeout(function(){ ableToChange = true; }, ableToChangeTimeout);
      }
    } else {                           
      if (!$("#revision").hasClass("positionFixed")) {
        $("#revision").removeClass().addClass("positionFixed");
      }
    }
  }
}
var windowHeight = $(window).height();
adjustFooterPosition();
setTimeout(function(){ adjustFooterPosition(); }, 2500);
adjustRevisionPosition();

// If mobile
function ifMobile() {
  var ifMobile = false;
  if ($("body").width() <= 720)
    ifMobile = true;
  return ifMobile;
}
// If IE
function ifIE() {
  var ua = window.navigator.userAgent;
  var msie = ua.indexOf('MSIE '); // IE 10 or older
  var trident = ua.indexOf('Trident/'); //IE 11
  return (msie > 0 || trident > 0);
}
var isIE = ifIE();

// Offline search highlight
function findGetParameter(t){for(var e=null,n=[],r=location.search.substr(1).split("&"),o=0;o<r.length;o++)(n=r[o].split("="))[0]===t&&(e=decodeURIComponent(n[1]));if(e)return e.replace("+"," ");else return e}
var zoomH = findGetParameter("zoom_highlightsub");
if (zoomH && zoomH.length >= 3) {
  $.getScript( "js/jquery.mark.min.js" ).done(function( script, textStatus ) { $("#topicText").mark(zoomH); });
}

// Catch and animate specific anchors like "topic.html#anchor"
$("#topicText").on("click", "a[href*=\\#]", function(e) {
  var filename = location.pathname.substring(location.pathname.lastIndexOf('/')+1);
  queryStringPositon = location.href.indexOf("?");
  if (queryStringPositon > -1) {
    filename = location.href.substring(queryStringPositon+1);
    filename = filename.substr(0, filename.lastIndexOf(".")) + ".html";
  }
  var dest = $(this).attr('href');
  var destTopicName = dest.substring(0, dest.lastIndexOf('#'));
  var destAnchor = dest.substring(dest.lastIndexOf('#'));
  if (filename != destTopicName)
    return;
  if ($(destAnchor)) {
    e.preventDefault();
    $('html,body').animate({ scrollTop: $(destAnchor).offset().top - 30 }, 'slow');
  }
});

// RTL floating images
function adjustRTLFloatImages() {
  $("html[dir='rtl'] #topicText img").each(function() {
    if ($(this).css("float") == "left") {
      $(this).css("float", "right");
      if ($(this).css("margin-right") != "0px") {
        $(this).css("margin-left", $(this).css("margin-right"));
        $(this).css("margin-right", "0");
      }
      }
  });
}
adjustRTLFloatImages();

// External links - icon addition
function extLinks() {
  // exclude RTL
  if ($("html").attr("dir") == "rtl");
  else { 
    var extLinkValid = true;
    $("#topicText a.weblink").each(function() {
      extLinkValid = true;
      // except help.eset.com
      if ($(this).attr("href").includes("help.eset.com"))
        extLinkValid = false;
      // except relative links
      if ($(this).attr("href").includes("http://") || $(this).attr("href").includes("https://"));
      else
        extLinkValid = false;
      if (extLinkValid)
        $(this).addClass('extLinkImg');
    });
  }
}
extLinks();

// If level1 navigation only, hide
function breadcrumbsHide() {
  if ($("#breadcrumbs")) {
    if ($("#breadcrumbs .page").text().includes(">") || $("#breadcrumbs .page").text().includes("<"));
    else {
      $("#breadcrumbs").removeClass().addClass("index");
    }
  }
}
breadcrumbsHide();

// Copy Table_Code contents to clipboard
function copyCodeToClipboard(copyIcon, tdElement) {
  var $temp = $("<textarea></textarea>");
  $("body").append($temp);
  $temp.val(tdElement.text()).select();
  document.execCommand("copy");
  $(copyIcon).addClass("copied");
  $(copyIcon).addClass("s-fading");
  $(copyIcon).css("display", "inline-block");
  $(copyIcon).fadeOut(2000, function() {
    $(copyIcon).removeClass("copied");
    $(copyIcon).removeClass("s-fading");
    if ($(copyIcon).is(':hover'))
      $(copyIcon).fadeIn(200);
    else
      $(copyIcon).css("display", "none");
  });
  $temp.remove();
}
function copyCode() {
  $("#topicText td.Table_code").each(function() {
    $(this).css("position", "relative");
    $(this).find("p").css("padding-right", "20px");
    $(this).append('<a href="javascript:copyThisCode()" class="codeURL"></a>');
    if (typeof str_copy_clipboard !== 'undefined') $(this).find("a.codeURL").attr("title", str_copy_clipboard); 
  });
  $("#topicText td.Table_code").hover(
    function() {
      $(this).find("a.codeURL").css("display", "inline-block");
    }, function() {
      if (!$(this).find("a.codeURL").hasClass("s-fading"))
        $(this).find("a.codeURL").css("display", "none");
    });
  $("#topicText").on("click", "a.codeURL", function(e) {
    copyCodeToClipboard($(this), $(this).parent());
    e.preventDefault();
    return false;
  });
}
function copyThisCode() {
  return false;
}
copyCode();

// Event resize
$( window ).resize(function() {
  windowHeight = $(window).height();
  resizeVSplitter();
  adjustFooterPosition();
  adjustRevisionPosition();
});

// Event scroll
$( window ).scroll(function() {
  moveScrollVSplitter();
  adjustRevisionPosition();
});

// Handling back/forward button
window.onpopstate = function(event) {
  window.location = document.location;
};

// Dummy
function HMTrackTopiclink(e) {return true;}
